#property strict
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_width1  4
#property indicator_width2  4
#property indicator_maximum 1
#property indicator_minimum 0

extern ENUM_TIMEFRAMES    TimeFrame  = PERIOD_CURRENT;
extern int                RSI_Period=13;             
extern ENUM_APPLIED_PRICE RSI_Price=PRICE_CLOSE;     
extern int                RSISignal_Period=2;        
extern ENUM_MA_METHOD     RSISignal_Method=MODE_SMA;   
extern int                TradeSignal_Period=7;      
extern ENUM_MA_METHOD     TradeSignal_Method=MODE_SMA; 
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsNotify    = false;
extern bool   alertsEmail     = false;
extern string soundFile       = "alert2.wav"; 


double gadRSI[];
double gadRSISig[];
double gadTradeSig[];
double gadTrendUp[];
double gadTrendDn[];
double trend[];
string indicatorFileName;
bool   returnBars;

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
int init() {
  IndicatorDigits(0);
  IndicatorBuffers(6);
      SetIndexBuffer(0, gadTrendUp);  SetIndexStyle(0,DRAW_HISTOGRAM); SetIndexLabel(0,"Trend Up");
      SetIndexBuffer(1, gadTrendDn);  SetIndexStyle(1,DRAW_HISTOGRAM); SetIndexLabel(1,"Trend Down");
      SetIndexBuffer(2, gadRSI);
      SetIndexBuffer(3, gadRSISig);
      SetIndexBuffer(4, gadTradeSig);
      SetIndexBuffer(5, trend);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
      IndicatorShortName(timeFrameToString(TimeFrame)+" TMS-Osc Histo");
  return(0);
}
int deinit() { return (0); }


//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
int start() {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int i,limit = MathMin(Bars-counted_bars,Bars-2);
         if (returnBars) { gadTrendUp[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      for(i=limit; i>=0; i--) gadRSI[i] = iRSI(NULL,0,RSI_Period,RSI_Price,i); 
      for(i=limit; i>=0; i--) 
      {
         gadRSISig[i]   = iMAOnArray(gadRSI,0,RSISignal_Period,0,RSISignal_Method,i);
         gadTradeSig[i] = iMAOnArray(gadRSI,0,TradeSignal_Period,0,TradeSignal_Method,i);    
         gadTrendUp[i]  = EMPTY_VALUE;
         gadTrendDn[i]  = EMPTY_VALUE;
         trend[i] = trend[i+1];
         if (gadRSISig[i]>gadTradeSig[i]) trend[i] =  1;
         if (gadRSISig[i]<gadTradeSig[i]) trend[i] = -1;
         if (trend[i] ==  1) gadTrendUp[i] = 1;
         if (trend[i] == -1) gadTrendDn[i] = 1;
      }
      manageAlerts();
      return(0);
   }  
   
   //
   //
   //
   //
   //
   
   limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-98,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         trend[i]      = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,RSI_Period,RSI_Price,RSISignal_Period,RSISignal_Method,TradeSignal_Period,TradeSignal_Method,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,5,y);
         gadTrendUp[i] = EMPTY_VALUE;
         gadTrendDn[i] = EMPTY_VALUE;
         if (trend[i] ==  1) gadTrendUp[i] = 1;
         if (trend[i] == -1) gadTrendDn[i] = 1;
   }
   return(0);
}

//-----------------------------------------------------------------------------
// 
//-----------------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
      static datetime time1 = 0;
      static string   mess1 = "";
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(time1,mess1,whichBar,"up");
         if (trend[whichBar] == -1) doAlert(time1,mess1,whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" TMS oscillator trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(StringConcatenate(message));
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," TMS oscillator trend change "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}